        subroutine daofindfile(image,list,daoname,ierr)

	character	image*(*),list*(*),number*3,daoname*(*),tst*128
	integer		ierr
        logical         exist

        if (list.eq.'default') goto 1

        inquire(file=list,exist=exist)
        if (exist) then
           ierr=0
           daoname=list
           return
        else
           ierr=1
           return
        end if

 1      inum=0
        daoname=' '

10	inum=inum+1
	if (inum.lt.10) then
		write(number,'(i1)') inum
	else if (inum.lt.100) then
		write(number,'(i2)') inum
	else if (inum.lt.1000)  then
		write(number,'(i3)') inum
	end if
	
	tst=image(1:lenc(image))//'.coo.'//number(1:lenc(number))	

	inquire(file=tst,exist=exist)

	if (exist) then
		daoname=tst
	end if

	if (inum.lt.100) goto 10

	if (daoname.eq.' ') then
		ierr=1
	else
		ierr=0
	end if

	return
	end

	subroutine daoformat(daoname,ierr)

	character*80	daoname,line

	open(unit=1,file=daoname,status='old')

	read(1,'(a)',iostat=ierr) line
        if (ierr.ne.0) return

	if (line(1:7).eq.'#K IRAF') then
		ierr=0
	else
		ierr=1
	end if

	close(unit=1)

	return
	end

	subroutine daogetpars(daoname,scale,sigma,fwhm,threshold,ierr)

	character*80	daoname,line,value

	open(unit=1,file=daoname,status='old')

	iline=0

10	read(1,'(a)',iostat=ierr) line
        if (ierr.ne.0) return

	iline=iline+1

	value=line(17:31)
	if (line(1:12).eq.'#K SCALE    ') read(value,*,err=99) scale
	if (line(1:12).eq.'#K SIGMA    ') read(value,*,err=99) sigma
	if (line(1:12).eq.'#K FWHMPSF  ') read(value,*,err=99) fwhm
	if (line(1:12).eq.'#K THRESHOLD') read(value,*,err=99) threshold

	if (iline.lt.40) goto 10

	if (scale*sigma*fwhm*threshold.eq.0.) goto 99
	ierr=0
	close(unit=1)
	return

99	ierr=1
	close(unit=1)
	return

	end

	subroutine daogetval(daoname,narray,nimag,xcen,ycen,mag,sharp,
     &		round)

	real		xcen(narray),ycen(narray),mag(narray),sharp(narray)
	real		round(narray)
	character*80	daoname,line

	real		x,y,m,s,r

	open(unit=1,file=daoname,status='old')

	nimag=0
	ierr=0
10	read(1,'(a)',err=99) line
	if (line(1:1).eq.'#') goto 10
	read(line,*) x,y,m,s,r
c	call gwrits(line,1)
	iline=1
	do 20 i=1,nimag
		if (m.gt.mag(i)) then
			iline=iline+1
		else
			goto 21
		end if
20	continue

21	continue
	nimag=nimag+1
	if (nimag.gt.narray) nimag=narray
	do 30 i=nimag,iline+1,-1
		xcen(i)=xcen(i-1)
		ycen(i)=ycen(i-1)
		mag(i)=mag(i-1)
		sharp(i)=sharp(i-1)
		round(i)=round(i-1)
30	continue

	if (iline.le.nimag) then
		xcen(iline)=x
		ycen(iline)=y
		mag(iline)=m
		sharp(iline)=s
		round(iline)=r
	end if

	goto 10

99	return
	end
	subroutine daoclose()

	close(unit=1)

	return
	end
