      subroutine listsub
      
      character image*128,header*60,string*128
      real      buf(2048)
      logical	within,outside
      
      
      call gproms('image',' ',' ',image,ierr)
      if (ierr.ne.0) return
      call gpromr('val1',0.0,' ',v0,ierr)
      if (ierr.ne.0) return
      call gpromr('val2',0.0,' ',v1,ierr)
      if (ierr.ne.0) return
      call gproml('outside',.true.,' ',outside,ierr)
      if (ierr.ne.0) return
      
      
      call gimopen(10,image,ierr)
      if (ierr.ne.0) then
         string=' LISTSUB: connot open file '//image
         call gwrits(string,2)
         return
      end if
      
      call gimhead(10,header,ncol,nrow,ierr)
      if (ierr.ne.0) return
      
      do 10 irow=1,nrow
         call gimrow(10,irow,ncol,buf,ierr)
         if (ierr.ne.0) return
         i0=0
         do 11 icol=1,ncol
            within=(buf(icol).lt.v0).or.(buf(icol).gt.v1)
            if (.not.outside) within=.not.within
            if (within.and.i0.eq.0) i0=icol
            if (.not.within.and.i0.ne.0) then
               write(string,'(1x,4i6)') i0,icol-1,irow,irow
               call gwrits(string,1)
               i0=0
            end if
 11      continue
         if (i0.ne.0) then
            write(string,'(1x,4i6)') i0,ncol,irow,irow
            call gwrits(string,1)
         end if
 10   continue
      
      call gimclose(10,ierr)

      return
      end
