      subroutine newradii(igal,nl,nhar,har,
     $     flag,inten,s,x,y,r,e,t,h,ierr)
      
      include 'param.inc'
      include 'declare.inc'
      
      integer nl,nhar(MAXLINE)
      real    har(2,2,MAXHARM,MAXLINE)
      character*128	string
      
c     this subroutine removes bad radii.
c     first find the largest radius useful for ellipsefitting
      
      call startsub('NEWRADII')
      
      imax=0
      do 20 i=1,nl
         if (nhar(i).ge.0) imax=i
 20   continue
      
      i=0
 30   if (i.lt.imax) then
         i=i+1
         if (nhar(i).lt.0) then
            do 31 j=i,imax
               if (nhar(j).ge.0) then
                  iok=j
                  goto 32
               end if
 31         continue

            write(string,'('' NEWRADII: ERROR '')')
            call gwrits(string,2)
            ierr=1
            return
            
 32         continue
            if (debug.ge.2) then
               write(string,'('' NEWRADII: bad interval '',
     &              3i4)') i,iok,imax
               call gwrits(string,1)
            end if
            call  removerad
     &           (igal,i,iok,imax,nhar,har,flag,inten,s,x,y,r,e,t,h)
         end if
         goto 30
      end if
      if (debug.ge.2) then
         write(string,'('' NEWRADII: reduced number of radii '',
     &        2i4)') nl,imax
         call gwrits(string,1)
      end if
 40   nl=imax
      
      
      ierr=0
      return
      end

      subroutine removerad(igal,i1,i2,nl,nhar,har,
     $     flag,inten,s,x,y,r,e,t,h)
      
      include 'param.inc'
      include 'declare.inc'

      integer nhar(MAXLINE)
      real    har(2,2,MAXHARM,MAXLINE)
      character*128	string
      
      call startsub('REMOVERAD')

      if (debug.ge.2) then
         write(string,'('' REMOVERAD: remove radii in interval '',
     &        2f10.2)') r(1,i1-1,igal),r(1,i2,igal)
         call gwrits(string,1)
      end if
      
      idif=i2-i1
      do 10 i=i2,nl
         do 11 j=1,2
            nhar(i-idif)=nhar(i)
            do 12 ih=1,MAXHARM
               do 13 k=1,2
		  har(j,k,ih,i-idif)=har(j,k,ih,i)
		  h(j,k,ih,i-idif,igal)=h(j,k,ih,i,igal)
 13            continue
 12         continue
            flag(j,i-idif,igal)=flag(j,i,igal)
            flag(j+2,i-idif,igal)=flag(j+2,i,igal)
            inten(j,i-idif,igal)=inten(j,i,igal)
            s(j,i-idif,igal)=s(j,i,igal)
            x(j,i-idif,igal)=x(j,i,igal)
            y(j,i-idif,igal)=y(j,i,igal)
            r(j,i-idif,igal)=r(j,i,igal)
            e(j,i-idif,igal)=e(j,i,igal)
            t(j,i-idif,igal)=t(j,i,igal)
 11      continue
 10   continue
      
      if (i1-1.eq.0) then
         r(2,i1-1,igal)=(r(1,i1-1,igal)+r(1,i1,igal))/2.
      end if
      
      nl=nl-idif
      
      
      return
      end
