	parameter(MAXGAL=1, MAXLINE=128, MAXHARM=9, MAXNPIX=5000*5000,
     &      MAXSAMP=2048, VALMIN=-32000, VALBAD=-33000.,NCOLMAX=64)
	parameter(pi=3.141592645)

c	common block with switches/parameter values for the fitting programs
c	most of these parameters are user-controlled

	common/photpar/
     &	iter1,iter2,hmax,nsammax,debug,npolres,
     &	rmin,rmax,radfac,rshap,rcen,errshap,errcen,dposmax,dellmax,
     &	dangmax,r1,r2,fracmin,cliplow,cliphigh,
     &  linear,outfill,extend

c		parameters for the setting up of the radius interval

	real	rmin,rmax,radfac
	logical	linear

c		parameters which determine the radial cutoffs for the
c		ellipse fitting

	real	rshap,rcen
	real	errshap,errcen

c		parameters which determine the number of iterations when
c		fitting ellipses

	integer	iter1,iter2

c		parameters needed for the ellipsefitting & harminical fitting

	integer	hmax
	real	dposmax,dellmax,dangmax

c		radial & azimuthal sampling parameters

	real	r1,r2
	integer	nsammax
	real	fracmin,cliphigh,cliplow

c		parameter for extending the radial range at the end

	logical extend

c		debugging

	integer	debug

c		parameters for the calculation of residuals

	logical	outfill
	integer	npolres

c		parameters for the setting up of the radius interval

	real	rmin0,rmax0,radfac0
	logical	linear0

c		parameters which determine the radial cutoffs for the
c		ellipse fitting

	real	rshap0,rcen0
	real	errshap0,errcen0

c		parameters which determine the number of iterations when
c		fitting ellipses

	integer	iter10,iter20

c		parameters needed for the ellipsefitting & harminical fitting

	integer	hmax0
	real	dposmax0,dellmax0,dangmax0

c		radial & azimuthal sampling parameters

	real	r10,r20
	integer	nsammax0
	real	fracmin0,cliphigh0,cliplow0

c		parameter for extending the radial range at the end

	logical extend0

c		debugging

	integer	debug0

c		parameters for the calculation of residuals

	logical	outfill0
	integer	npolres0
