      subroutine checkinput(image,output,intable,outtable,nx,ny,ierr)

      character*128 image,output,intable,outtable
      integer       nx,ny

      include 'param.inc'

      character*128 string

c     this subroutine should check 
c     -whether image & output exis
c     -whether intable & outtable exist
c     -if rmax > 0
c     -the existence of output table & image

      if (nx*ny.gt.MAXNPIX) then
         write(string,'('' ERROR: IMAGE TOO LARGE: max(nx*ny)='',i8)') 
     $        MAXNPIX
         call gwrits(string,1)
         ierr=1
         return
      else
         if (debug.ge.2) then
            write(string,'('' CHECKINPUT: nx * ny ='',i6,
     $           '' < MAXNPIX = '',
     $           i6)') nx*ny, MAXNPIX
            call gwrits(string,1)
         end if
      end if

      if (rmax.eq.0.) then
         rmax=sqrt(float(nx)**2+float(ny)**2)
         if (debug.ge.2) then
            write(string,'('' CHECKINPUT: new rmax = '',g15.5)') rmax
            call gwrits(string,1)
         end if
      end if

      return
      end
