      subroutine getcen(ngal,xcen,ycen,image,galaxy,ierr)
      
c     this subroutine retrieves the centers of the galaxies
c     these are stored in the files defined by 'image' and 'string'
      
      
      real	xcen(ngal),ycen(ngal)
      character*(*)	image,galaxy
      
      include 'param.inc'
      
      logical	exist
      character*128	string,galname
      
      call startsub('GETCEN')
      
      galname=galaxy
      call imname(image,galname)
      
      inquire(file=galname,exist=exist)
      if (.not.exist) then
         write(string,'('' GETCEN: ERROR: no file '',a)')
     &        galname(1:80)
         call gwrits(string,2)
         ierr=1
         return
      end if
      
      open(unit=1,file=galname,status='old',iostat=iostat)
      if (iostat.ne.0) then
         write(string,'('' GETCEN: ERROR: cannot open file '',a)')
     &        galname(1:80)
         call gwrits(string,2)
         ierr=1
         return
      end if
      if (debug.ge.2) then
         write(string,'('' GETCEN: file opened '',a)')  galname(1:80)
         call gwrits(string,1)
      end if
      
      do 10 i=1,ngal
         read(1,'(a)') string
         if (i.eq.ngal) then
            read(string,*,iostat=iostat) xcen(1),ycen(1)
            if (iostat.ne.0) then
               write(string,'('' GETCEN: ERROR: error reading '',a)')
     &              string(1:80)
               call gwrits(string,2)
               ierr=1
               return
            end if
         end if
 10   continue
      
      close(unit=1)
      if (debug.ge.2) then
         write(string,'('' GETCEN: readin entry'',i4)') ngal
         call gwrits(string,1)
      end if
      
      ngal=1
      ierr=0
      
      return
      end
