      subroutine newintens(nl,inten,nhar,har,igal,ldif,ierr)
      
c     subroutine updates intensity array
      
      include 'param.inc'
      include 'declare.inc'
      
      real	har(2,2,MAXHARM,MAXLINE)
      integer nhar(MAXLINE)
      logical ldif
      character*128	string
      
      call startsub('NEWINTENS')
      
      do 10 il=1,nl
         if (nhar(il).lt.0) then
            write(string,'('' NEWINTENS: ERROR: nhar <0 '')')
            call gwrits(string,2)
            ierr=1
            return
         end if
         if (inten(1,il,igal).lt.VALMIN.and.ldif) then
            write(string,'('' NEWINTENS: ERROR: inten < VALMIN '')')
            call gwrits(string,2)
            ierr=1
            return
         end if
         if (har(1,1,1,il).le.VALMIN) then
            write(string,'('' NEWINTENS: ERROR: har <0 '',
     $           g15.5)') har(1,1,1,il)
            call  gwrits(string,2)
            ierr=1
            return
         end if
         if (ldif) then
            inten(1,il,igal)=inten(1,il,igal)+har(1,1,1,il)
         else
            inten(1,il,igal)=har(1,1,1,il)
         end if
         inten(2,il,igal)=har(2,1,1,il)
         
         if (debug.ge.3) then
            write(string,'('' NEWINTENS: '',3g12.4)')
     &           inten(1,il,igal),inten(2,il,igal),har(1,1,1,il)
            call gwrits(string,1)
         end if
 10   continue
      
      ierr=0
      return
      end	
